//putpix.c (from ABEDEMO)

#include <dos.h>
#include <conio.h>

//; Mode X (320x240, 256 colors) rectangle fill routine. Works on all
//; VGAs. Uses slow approach that selects the plane explicitly for each
//; pixel. Fills up to but not including the column at EndX and the row
//; at EndY. No clipping is performed.
//; C near-callable as:
//;    void FillRectangleX(int StartX, int StartY, int EndX, int EndY,
//;       unsigned int PageBase, int Color);

void FillRectangleX(int, int, int, int, unsigned int, int);
void Set320x240Mode(void);

/* wtsync waits for the vertical retrace
That is when the electron beam jumps back from the bottom right corner
of the screen to the upper left corner of the screen 
This gives us a chance to draw things on the screen, changing the palette and
stuff like that while the electron beam aint drawing */
void wtsync(void)
{
asm     mov     dx,3DAh
WaitVR1:
asm     in      al,dx
asm     test    al,8
asm     jne     WaitVR1
WaitVR2:
asm     in      al,dx
asm     test    al,8
asm     je      WaitVR2
}

/* sets the 256 colours of the palette to the 256 first colours of pal */
void setpal(char*pal)
{
int i;
	outp(0x3c8,0);          /* set colorindex to 0 */
//	for(i=0;i<256*3;i++)
	for(i=0;i<256*3;i++)
	outp(0x3c9,pal[i]);     /* send palette-data to the palette */
}

/* reads the current palette and saves it in the array pal */
void getpal(char*pal)
{
int i;
	outp(0x3c7,0);
	for(i=0;i<256*3;i++)
	pal[i]=inp(0x3c9);
}

/* this function sets up a pal with smooth colorruns between some neat colours
 feel free to change the colours and see what it looks like */
void coolpal(char*pal)
{
int i,r=0,g=0,b=0,col=0;

outp(0x3c8,0);

	for(i=0;i<64;i++)      // BLACK - WHITE
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(r<63)r++;
		if(g<63)g++;
		if(b<63)b++;
	}
	for(i=0;i<64;i++)      // WHITE - YELLOW
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(b>0)b--;
	}
	for(i=0;i<64;i++)      // YELLOW - DARK BLUE
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(r>0)r--;
		if(g>0)g--;
		if(b<63 && i%2==0)b++;
	}
	for(i=0;i<64;i++)      // DARKBLUE - GREEN
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(g<63)g++;
		if(b>0 && i%2==0)b--;
	}
	for(i=0;i<64;i++)      // GREEN - DARK RED
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(r<63 && i%2==0)r++;
		if(g>0)g--;
	}
	for(i=0;i<64;i++)      // DARKRED - 63 00 31
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(r<63 && i%2==0)r++;
		if(b<63 && i%2==0)b++;
	}
	for(i=0;i<64;i++)      // 63 00 31 - 00 31 63
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(b<63 && i%2==0)b++;
		if(g<63 && i%2==0)g++;
		if(r>0)r--;
	}
	for(i=0;i<64;i++)      // 00 31 63 - BLACK (00 00 00)
	{
		pal[col++]=r;
		pal[col++]=g;
		pal[col++]=b;
		if(b>0)b--;
		if(g>0 && i%2==0)g--;
	}

setpal(pal);                    // set the first 256 colours of pal
}

/* rotates the colours first - last in the array pal */
void rotpal(char*pal,int first, int last)
{
char r,g,b;
int i;

r=pal[first*3 + 0];             //save the first color in r,g,b
g=pal[first*3 + 1];
b=pal[first*3 + 2];

for(i=first*3;i<(last+1)*3;i++) //move all colors down one step (3 bytes)
pal[i]=pal[i+3];

pal[last*3+0]=r;                 //set the last color to r,g,b
pal[last*3+1]=g;
pal[last*3+2]=b;

wtsync();                       //wait for the vertical retrace
setpal(pal);                    //and set the first 256 colours of pal
}

void main() {

   char pal[512*3];
	    //Use 512 colours 4 the palette (only 256 visible at a time)

   int i,j;
   union REGS regset;

   Set320x240Mode();

   for (j = 1; j < 220; j += 16) {
      for (i = 1; i < 300; i += 16) {
	 FillRectangleX(i, j, i+14, j+14, 0, ((j/16*15)+i/16) /*& 0xFF*/);
      }
   }
   getch();

   do
{
	/* now just rotate the palette */
	/* until the keyboard is hit */
	
	rotpal(pal,1,511);

	/* notice that colour 0 is not rotated, that is because I don't */
	/* want the backgroundcolor to change */

}while(!kbhit());       

   regset.x.ax = 0x0003;   /* switch back to text mode and done */
   int86(0x10, &regset, &regset);
}



